""" mcdutils product interfaces

$Id: interfaces.py,v 1.3 2006/05/31 20:57:16 tseaver Exp $
"""
from transaction.interfaces import IDataManager
from zope.interface import Attribute
from zope.interface import Interface

class ISessionDataContainer(Interface):
    """ Document the implied interface expected by Zope2's SessionDataManager.
    """
    def has_key(key):
        """ Return True if the container has the key, else False.
        """

    def new_or_existing(key):
        """ Return a mapping for 'key', creating it if needed.

        o The returned object must be Acquisition-wrappable.
        """

    def get(key):
        """ Return a mapping for 'key'.

        o Return None of no mapping exists.

        o If not None, the returned object must be Acquisition-wrappable.
        """

class IMemCacheMapping(IDataManager):
    """ Combine Python's mapping protocol with transaction management.
    """

class IMemCacheProxy(Interface):
    """ Manage client connection to a pool of memcached servers.
    """
    servers = Attribute(u'servers', u"""List of servers

Each item is a <host>:<port> server address.""")

    client = Attribute(u'client', u"""memcache.Client instance"""
                      )
    client.setTaggedValue('read_only', True)

    def get(key):
        """ Return a mapping for 'key'.
        """

    def set(key, value):
        """ Store value (a mapping) for 'key'.
        """

    def create(key):
        """ Create a new mapping for 'key'.
        """

class IMemCacheSessionDataContainer(ISessionDataContainer):
    """ memcache-specific SDC, using a proxy.
    """
    proxy_path = Attribute(u"""Path to proxy.

No session operations are possible if the path is invalid.""")
